/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>

typedef struct gproc gproc;
struct gproc
{
	char *name[9];
	gproc *n;
	gproc *p;
};

Image *textc;
Image *hoverc;
Image *hovertc;
Image *borderc;
Image *backc;
Image *backtc;
Image *scrollc;
Image *sortc;
Image *sorttc;

gproc *glist, *oglist;
int f[10], sel, osel, scr, oscr, view, nall, partd, sortn;
Rectangle scroll;
char flags;

enum
{
	AFLAG = 0x1,
	PFLAG = 0x2,
	DFLAG = 0x4,
};

char *buttons[] =
{
	"kill",
	"refresh",
	"all",
	"pri",
	"exit",
	0,
};

char *title[] =
{
	"user",
	"id",
	"utime",
	"stime",
	"pri0",
	"pri1",
	"size",
	"state",
	"cmd",
	0
};

enum {
	KILL = 0x0,
	REFRESH,
	ALL,
	PRI,
	EXIT
};

Menu menu =
{
	buttons
};

void *
reallocg(void *v, ulong n)
{
	v = realloc(v, n);
	if(v == nil)
		sysfatal("no memory allocable.");

	return v;
}

char *
strdupg(char *s)
{
	char *ret;

	ret = reallocg(nil, strlen(s) + 1);
	strcpy(ret, s);
	ret[strlen(s)] = '\0';

	return ret;
}

void
free_gproc(gproc *gl)
{
	char i;

	if(gl != nil)
	{
		i = -1;
		while(++i < 9)
			if(gl->name[i] != nil)
				free(gl->name[i]);

		free(gl);
	}
	return;
}

void
free_gprocl(gproc *gn)
{
	int n;

	n = -1;

	while(gn != nil)
	{
		if(gn->n != nil)
		{
			gn = gn->n;
			free_gproc(gn->p);
			n++;
		} else {
			free_gproc(gn);
			return;
		}
	}
	return;
}

gproc *
get_num(gproc *t, int n)
{

	while(--n > 0)
		if(t != nil)
			t = t->n;
	return t;
}

int
get_n(gproc *t)
{
	int ret;

	ret = 0;

	while(t->n != nil)
	{
		ret++;
		t = t->n;
	}

	return ret;
}

int
compare(gproc *a, gproc *b)
{
	int i;

	if(strlen(a->name[sortn]) > strlen(b->name[sortn]))
		return -1;
	if(strlen(a->name[sortn]) < strlen(b->name[sortn]))
		return 1;

	i = -1;
	while((a->name[sortn])[++i] != '\0')
	{
		if((a->name[sortn])[i] < (b->name[sortn])[i])
			return 1;
		if((a->name[sortn])[i] > (b->name[sortn])[i])
			return -1;
	}

	return -1;
}

gproc *
insertsort(gproc *g, short dir)
{
	gproc *s, *n;
	char *t;
	int i;

	if(sortn == -1 || g->n == nil)
		return g;

	s = g;

	while(s->n != nil)
	{
		n = s;
		while(n != nil)
		{
 			if(compare(n->n, n) == dir)
			{
				if(n->n != n)
				{
					i = -1;
					while(++i < 9)
					{
						t = n->name[i];
						n->name[i] = n->n->name[i];
						n->n->name[i] = t;
					}
				}
			}
			n = n->p;
		}

		s = s->n;
	}

	return g;
}

void
get_conven(gproc *g)
{
	int n;
	char *c;

	while(g != nil)
	{
		n = atol(g->name[2]) / 1000;
		c = reallocg(nil, 12);
		snprint(c, 12, "%d:%.2d", n / 60, n % 60);
		free(g->name[2]);
		g->name[2] = c;

		n = atol(g->name[3]) / 1000;
		c = reallocg(nil, 12);
		snprint(c, 12, "%d:%.2d", n / 60, n % 60);
		free(g->name[3]);
		g->name[3] = c;
	
		g = g->n;
	}

	return;
}

/*void
get_deltas(gproc *l, gproc *ol)
{
	int fd, n, av, t;
	char stats[121];

	n = av = 0;

	fd = open("#c/sysstat", OREAD);
	if(fd < 0)
		return;

	while(read(fd, stats, 120) == 120)
	{
		n++;
		av += atol(stats + 84);
	}
	close(fd);

	av /= n;
	t = 0;

	while(l != nil && ol != nil)
	{
		n = ((atol(l->name[2]) - atol(ol->name[2])) / 2)
			+ ((atol(l->name[3]) - atol(ol->name[2])) / 2);
		
		
		

}*/

gproc *
get_psdata(void)
{
	gproc *ret, *b, *a;
	Dir *dir;
	int fd, tot, dfd, n;
	char status[178], args[256], *c;

	ret = nil;
	b = nil;
	a = nil;

	if(chdir("/proc") < 0)
		return nil;

	fd = open(".", OREAD);
	if(fd < 0)
		return nil;

	tot = dirreadall(fd, &dir);
	if(tot <= 0)
	{
		close(fd);
		return nil;
	}
	close(fd);

	while(--tot >= 0)
	{
		if(b != a)
			free_gproc(a);

		a = reallocg(nil, sizeof(gproc));
		memset(a, 0, sizeof(gproc));
		a->n = nil;
		a->p = nil;

		a->name[1] = strdupg(dir[tot].name);

		snprint(status, 177, "%s/status", a->name[1]);
		dfd = open(status, OREAD);
		if(dfd < 0)
			continue;

		status[177] = '\0';
		n = read(dfd, status, 176);
		if(n < 0)
			continue;
		close(dfd);

		c = strchr(status, ' ');
		if(c == nil)
			continue;
		*c = '\0';
		c = strchr(status + 28, ' ');
		if(c == nil)
			continue;
		*c = '\0';
		c = strchr(status + 56, ' ');
		if(c == nil)
			continue;
		*c = '\0';

		a->name[0] = strdupg(status + 28);

		n = atol(status + 152);
		c = reallocg(nil, 3);
		snprint(c, 3, "%d", n);
		a->name[4] = c;

		n = atol(status + 164);
		c = reallocg(nil, 3);
		snprint(c, 3, "%d", n);
		a->name[5] = c;

		c = reallocg(nil, 12);
		snprint(c, 12, "%d", (int)atol(status + 68));
		a->name[2] = c;

		c = reallocg(nil, 12);
		snprint(c, 12, "%d", (int)atol(status + 80));
		a->name[3] = c;

		n = atol(status + 140);
		c = reallocg(nil, 12);
		snprint(c, 12, "%dK", n);
		a->name[6] = c;

		a->name[7] = strdupg(status + 56);
		a->name[8] = strdupg(status);

		if(flags & AFLAG)
		{
			snprint(status, 177, "%s/args", a->name[1]);
			dfd = open(status, OREAD);
			if(dfd < 0)
				continue;

			n = read(dfd, args, 255);
			close(dfd);
			if(n < 0)
				continue;

			args[n] = '\0';
			if(n > 0)
			{
				free(a->name[8]);
				a->name[8] = strdupg(args);
			}
		}

		if(b != nil)
			b->n = a;
		a->p = b;

		b = a;
		if(ret == nil)
			ret = a;
	}
	free(dir);

	ret = insertsort(ret, -1);

	return ret;
}

void
draw_scrollbar(Rectangle r)
{

	partd = Dy(r) / nall;

	draw(screen, r, scrollc, nil, ZP);
	if((scr + view) * partd <= Dy(r))
	{
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.min.y + partd * (scr + view)), backc, nil, ZP);
	} else {
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.max.y), backc, nil, ZP);
	}

	return;
}

void
draw_ps(int g)
{
	int e, d;
	gproc *n, *no;
	Point max;
	char *a;

	if(g > 0)
	{
		if(glist != nil)
		{
			if(oglist != nil)
				free_gprocl(oglist);
			oglist = glist;
		}

		glist = get_psdata();
	/*	if(flags & DFLAG)
		{
			get_deltas(glist, oglist);
		} else {*/
			get_conven(glist);
	//	}
	}

	e = (screen->r.max.x - screen->r.min.x - 15) / ((flags & PFLAG) ? 77 : 69);

	if(g > 3)
		draw(screen, screen->r, backc, nil, ZP);

	max = screen->r.max;
	max.y--;
	max.x--;

	d = screen->r.min.x;

	if(g > 3)
	{
		line(screen, (Point){d, screen->r.min.y}, (Point){max.x, screen->r.min.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){max.x, screen->r.min.y}, max, 0, 0, 0, borderc, ZP);
		line(screen, max, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){d, max.y}, (Point){d, screen->r.min.y}, 0, 0, 0, borderc, ZP);
	}

	f[0] = screen->r.min.x + 12;
	d += 12;
	scroll = Rect(screen->r.min.x + 1, screen->r.min.y + 3 + font->height, d, screen->r.max.y - 1);
	if(g > 3)
	{
		draw(screen, Rect(screen->r.min.x + 1, screen->r.min.y + 1, d, screen->r.min.y + 2 + font->height), borderc, nil, ZP);
		draw(screen, Rect(screen->r.min.x + 2, screen->r.min.y + 2, d - 1, screen->r.min.y + 1 + font->height), backtc, nil, ZP);
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	}

 	d += 10 * e;
	f[1] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 7 * e;
	f[2] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 7 * e;
	f[3] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 7 * e;
	f[4] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	if(flags & PFLAG)
	{
		d += 4 * e;
		f[5] = d;
		if(g > 3)
			line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
		d += 4 * e;
		f[6] = d;
		if(g > 3)
				line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	}
	if(!(flags & PFLAG))
		f[6] = f[4];
	d += 8 * e;
	f[7] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 8 * e;
	f[8] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	f[9] = max.x;
	if(g > 3)
		line(screen, (Point){screen->r.min.x, screen->r.min.y + font->height + 2}, (Point){max.x, screen->r.min.y + font->height + 2}, 0, 0, 0, borderc, ZP);


	if(g > 2)
	{
		e = -1;
		while(title[++e] != 0)
		{
			if(!(flags & PFLAG))
				if(e == 4 || e == 5)
					continue;

			draw(screen, Rect(f[e] + 1, screen->r.min.y + 1, f[e + 1], screen->r.min.y + 2 + font->height), (e == sortn) ? sortc : backtc, nil, ZP);

			a = strdupg(title[e]);
			if(stringwidth(font, a) >= f[e + 1] - f[e])
				a[strlen(a) - ((stringwidth(font, a) - f[e + 1] + f[e] + 2) / (stringwidth(font, a) / strlen(a)) + 1)] = '\0';
			string(screen, (Point){f[e] + (f[e + 1] - f[e]) / 2 - stringwidth(font, a) / 2, screen->r.min.y + 1}, (e == sortn) ? sorttc : textc, ZP, font, a);
			free(a);
		}
	}

	d = 0;
	n = get_num(glist, scr);
	no = get_num(oglist, scr);
	while(n != nil && ((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 9)
		{
			if(!(flags & PFLAG))
				if(e == 4 || e == 5)
					continue;

			if(no != nil && g < 1 && d != sel && d != osel)
				if(!strcmp(no->name[e], n->name[e]))
					goto items_none;

			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), (d == sel) ? hoverc : backc, nil, ZP);

			if(n->name[e] != nil)
			{
				if(stringwidth(font, n->name[e]) >= f[e + 1] - f[e])
					(n->name[e])[strlen(n->name[e]) - ((stringwidth(font, n->name[e]) - f[e + 1] + f[e]) / (stringwidth(font, n->name[e]) / strlen(n->name[e])) + 1)] = '\0';
				string(screen, (Point){f[e] + 2, screen->r.min.y + 3 + font->height * d}, (d == sel) ? hovertc : textc, ZP, font, n->name[e]);
			}
		}
items_none:
		if(no != nil)
			no = no->n;
		n = n->n;
	}

	while(((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 9)
		{
			if(!(flags & PFLAG))
				if(e == 4 || e == 5)
					continue;
			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), backc, nil, ZP);
		}
	}

	if(g > 1)
		view = d;
	nall = get_n(glist);

	draw_scrollbar(scroll);

	return;
}

void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0)
		sysfatal("can't reattach to window");

	draw_ps(4);

	return;
}

void
usage(void)
{

	print("usage: gtop [-apd] [-s sec]\n");
	return;
}

void
main(int argc, char *argv[])
{
	int sec, Etimer, fd;
	Event e;
	gproc *a;
	char *b, *s;

	sec = 2;
	scr = 0;
	sel = -1;
	flags = '\0';
	sortn = -1;

	if(initdraw(nil, nil, "gtop") < 0)
		sysfatal("initdraw failed: %r");

	ARGBEGIN {
		case 's':
			sec = atoi(ARGF());
			break;
		case 'a':
			flags |= AFLAG;
			break;
		case 'p':
			flags |= PFLAG;
			break;
		case 'd':
			flags |= DFLAG;
			break;
		default:
			usage();
			exits(0);
	} ARGEND;

	backc = allocimagemix(display, DPaleyellow, DWhite);
	if(backc == nil)
		sysfatal("allocimagemix: %r");
	textc = allocimagemix(display, DBlack, DBlack);
	if(textc == nil)
		sysfatal("allocimagemix: %r");
	hoverc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(hoverc == nil)
		sysfatal("allocimagemix: %r");
	borderc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(borderc == nil)
		sysfatal("allocimagemix: %r");
	hovertc = allocimagemix(display, DBlack, DBlack);
	if(hovertc == nil)
		sysfatal("allocimagemix: %r");
	backtc = allocimagemix(display, DPalebluegreen, DWhite);
	if(backtc == nil)
		sysfatal("allocimagemix: %r");
	scrollc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(scrollc == nil)
		sysfatal("allocimagemix: %r");
	sortc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(sortc == nil)
		sysfatal("allocimagemix: %r");
	sorttc = allocimagemix(display, DBlack, DBlack);
	if(sorttc == nil)
		sysfatal("allocimagemix: %r");

	eresized(0);

	einit(Emouse);
	Etimer = etimer(0, sec * 1000);

	while(1)
	{
		switch(eread(Emouse|Etimer, &e))
		{
			case Emouse:
				if(e.mouse.buttons & 1)
				{
					if(e.mouse.xy.y < screen->r.min.y + font->height + 2)
					{
						fd = -1;
						while(++fd < 9)
						{
							if(!(flags & PFLAG))
								if(fd == 4 || fd == 5)
									continue;
							if(e.mouse.xy.x < f[fd + 1] && e.mouse.xy.x >= f[fd])
							{
								if(sortn == fd)
								{
									sortn = -1;
								} else {
									sortn = fd;
								}
								draw_ps(3);
								break;
							}
						}
						break;
					}
					if(e.mouse.xy.x < screen->r.min.x + 15)
					{
						if((scr - view / 2) <= 0)
						{
							scr = 0;
						} else {
							scr -= view / 2;
						}

						draw_ps(2);
					} else {
						osel = sel;
						fd = (e.mouse.xy.y - screen->r.min.y - 1) / font->height;
						if(fd == sel)
						{
							sel = 0;
						} else {
							sel = fd;
						}

						draw_ps(0);
					}
					break;
				}
				if(e.mouse.buttons & 2)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr = (e.mouse.xy.y - scroll.min.y) / partd;
						draw_ps(2);
					}
					break;
				}
				if(e.mouse.buttons & 4)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr += view / 2;
						draw_ps(2);
						break;
					}
					switch(epiemenuhit(3, &e.mouse, &menu))
					{
						case KILL:
							s = "kill\n";

							a = get_num(glist, sel);
							if(a != nil)
							{
								b = reallocg(nil, 64);
								snprint(b, 63, "/proc/%s/note", a->name[1]);

								fd = open(b, OWRITE);
								free(b);
								if(fd < 0)
								{
									perror("open");
									break;
								}

								write(fd, s, strlen(s));
								close(fd);
							}

							draw_ps(1);
							break;
						case REFRESH:
							draw_ps(1);
							break;
						case ALL:
							flags ^= AFLAG;
							draw_ps(4);
							break;
						case PRI:
							flags ^= PFLAG;
							draw_ps(4);
							break;
						case EXIT:
							goto free_all;
						default:
							break;
					}
				}
				break;
			default:
				draw_ps(1);
				break;
		}
		sleep(1);
	}

free_all:

	freeimage(textc);
	freeimage(hoverc);
	freeimage(backc);
	freeimage(hovertc);
	freeimage(borderc);
	freeimage(backtc);
	freeimage(scrollc);
	freeimage(sortc);
	freeimage(sorttc);

	if(glist != nil)
		free_gprocl(glist);
	if(oglist != nil)
		free_gprocl(oglist);

	exits(0);
}
